﻿-- REQUIRED Combuctor
local CombuctorSet = Combuctor:GetModule("Sets")

-- Localization
local L = LibStub("AceLocale-3.0"):GetLocale("Combuctor_Peche")

-- Profession Icon Name
local IconPathName = "Interface/Icons/trade_fishing"
local ProfessionName = select(10, GetAuctionItemSubClasses(7))

-- AucItemClasses
local Class_Recipe = select(7, GetAuctionItemClasses())

-- AucItemClasses
local Class_Other = select(13, GetAuctionItemSubClasses(6))

-- Tab Names
local TN = {}
TN.All = ALL 
TN.Other = Class_Other
TN.Recipes = Class_Recipe

-----------------------------------------------------------------------------------------------------------------------------------------
local function GetItemIDFromLink(itemLink)
	if not itemLink or itemLink=="" then return nil end

	local itemString = string.match(itemLink, "item[%-?%d:]+")
	local linkType, itemId, enchantId,jewelId1, jewelId2, jewelId3, jewelId4,suffixId, uniqueId = strsplit(":", itemString)
	if (linkType == 'item') then
		return itemId
	end

end
-----------------------------------------------------------------------------------------------------------------------------------------
function TN.isFirstAid(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return TN.isFish(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	or TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	or TN.isRecipe(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc);
end
-----------------------------------------------------------------------------------------------------------------------------------------
function TN.isFish(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	if not link then return false end

	local ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	
	return Poissons_Peche[tonumber(ItemID)];
end
-----------------------------------------------------------------------------------------------------------------------------------------
function TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	if not link then return false end

	local ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	
	return Divers_Peche[tonumber(ItemID)];
end
-----------------------------------------------------------------------------------------------------------------------------------------
function TN.isRecipe(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	return (type==Class_Recipe and subType==ProfessionName)
end
-----------------------------------------------------------------------------------------------------------------------------------------
CombuctorSet:Register(ProfessionName, IconPathName, TN.isFirstAid)

CombuctorSet:RegisterSubSet(TN.All,				ProfessionName,nil,TN.isFirstAid)
CombuctorSet:RegisterSubSet(L["Fish"],			ProfessionName,nil,TN.isFish)
CombuctorSet:RegisterSubSet(TN.Other,		ProfessionName,nil,TN.isOther)
CombuctorSet:RegisterSubSet(TN.Recipes,	ProfessionName,nil,TN.isRecipe)